from __future__ import print_function, division

class Rules(object):
    _list = None

    def __iter__(self):
	if self._list is None:
	    self.list()
	return self._list.__iter__()

    def __getitem__(self, *x):
	if self._list is None:
	    self.list()
	return self._list.__getitem__(*x)

    def __len__(self):
	if self._list is None:
	    self.list()
	return self._list.__len__()

    def list(self):
	if self._list is None:
	    self._list = []
	    for fun in self.rule_list:
		fun(self, self._list)
	return self._list

class GridFillingRules(Rules):
    # every cell contains at most 1 color
    def cell_most_1(self, dest):
	term = self.game.term
	for x in range(self.game.width):
	    for y in range(self.game.height):
		for n in range(self.game.colors):
		    for i in range(n):
			dest.append([-term(x,y,i), -term(x,y,n)])

    # every cell contains at least 1 color
    def cell_least_1(self, dest):
	term = self.game.term
	for x in range(self.game.width):
	    for y in range(self.game.height):
		dest.append([term(x,y,n) for n in range(self.game.colors)])

    rule_list = [cell_most_1, cell_least_1]
